ElgohLootButton={};
local height=_G["LootButton1"]:GetHeight();
for i=1, 4 do
	local name="ElgohLootButton"..i.."MS";
	ElgohLootButton[i]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
	ElgohLootButton[i]:SetWidth(height)
	ElgohLootButton[i]:SetHeight(height)
	local button=_G["LootButton"..i];
	ElgohLootButton[i]:SetPoint("TOP", button, "TOP", 0, 0);
	ElgohLootButton[i]:SetPoint("LEFT", _G["LootFrame"], "RIGHT", -65, 0);
	ElgohLootButton[i]:SetScript("OnClick", function(self) Elgoh_LootButton(self); end);
	
	local name="ElgohLootButton"..i.."OS";
	ElgohLootButton[i+4]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
	ElgohLootButton[i+4]:SetWidth(height)
	ElgohLootButton[i+4]:SetHeight(height)
	ElgohLootButton[i+4]:SetPoint("TOP", button, "TOP", 0, 0);
	ElgohLootButton[i+4]:SetPoint("LEFT", _G["ElgohLootButton"..i.."MS"], "RIGHT", 5, 0);
	ElgohLootButton[i+4]:SetScript("OnClick", function(self) Elgoh_LootButton(self); end);
	
	ElgohLootButton[i]:SetText("MS");
	ElgohLootButton[i+4]:SetText("OS");
	
	ElgohLootButton[i]:Hide();
	ElgohLootButton[i+4]:Hide();
end

ElgohLootButtonLink=CreateFrame("Button",nil,_G["LootFrame"],"UIPanelButtonTemplate")
ElgohLootButtonLink:SetWidth(100)
ElgohLootButtonLink:SetHeight(25)
ElgohLootButtonLink:SetPoint("TOP", _G["LootFrame"], "TOP", 0, -40);
ElgohLootButtonLink:SetPoint("LEFT", _G["LootFrame"], "LEFT", 75, 0);
ElgohLootButtonLink:SetScript("OnClick", function() Elgoh_LootShow(1); end);
ElgohLootButtonLink:SetText("Link");
ElgohLootButtonLink:Hide();

function Elgoh_LootButton(self)
	local item=string.sub(self:GetName(), 16,16);
	local spec=string.sub(self:GetName(), 17,18);
	local itemLink=GetLootSlotLink(item);
	if itemLink==nil then return; end
	local message;
	if(spec=="MS") then
		message=string.gsub(ElgohSettings["MSString"], "ITEM", itemLink)
	elseif(spec=="OS") then
		message=string.gsub(ElgohSettings["OSString"], "ITEM", itemLink)
	end
	EDebug(message);
	SendChatMessage(message, "RAID_WARNING");
	LootingReset();
	Elgoh_RefreshLootList();
	ElgohRolling=1;
end

function Elgoh_RaiderInterested(name)
	if(ElgohRolling==0) then return; end
	for i=1,#InterestedRaiders do
		if(InterestedRaiders[i]==name) then return; end
	end
	tinsert(InterestedRaiders, name);
	Elgoh_RefreshLootList();
end

function LootingReset()
	InterestedRaiders={};
	ElgohRolling=0;
	if(ElgohLootFrame~=nil) then ElgohLootFrame:Hide(); end
end

function Elgoh_RefreshLootList()
	if(ElgohLootFrame==nil) then
		ElgohLootFrame=CreateFrame("Frame","ElgohLootFrame")
		ElgohLootFrame:SetWidth(100)
		ElgohLootFrame:SetHeight(100)
		ElgohLootFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		ElgohLootFrame:SetBackdropColor(0,0,0,1);
		ElgohLootFrame:SetPoint("CENTER", UIParent);
		ElgohLootFrame:SetMovable(true);
		ElgohLootFrame:RegisterForDrag("LeftButton");
		ElgohLootFrame:SetScript("OnDragStart", ElgohLootFrame.StartMoving);
		ElgohLootFrame:SetScript("OnDragStop", ElgohLootFrame.StopMovingOrSizing);
		ElgohLootFrame:SetUserPlaced(true)
		
		ELFLabel=ElgohLootFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal");
		ELFLabel:SetHeight(10);
		ELFLabel:SetPoint("TOP", ElgohLootFrame, "TOP", 0, 0);
		
		ELFButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ELFButton:SetPoint("BOTTOM", ElgohLootFrame, "BOTTOM", 0,-10)
		ELFButton:SetWidth(80)
		ELFButton:SetHeight(22)
		ELFButton:SetText("Finish");
		ELFButton:SetScript("OnClick", LootingReset);
	end
	table.sort(InterestedRaiders, Elgoh_SortLooters);
	if(#InterestedRaiders>0) then ElgohLootFrame:Show(); else ElgohLootFrame:Hide(); end
	for i=1, 5 do
		if(ElgohLooters[i]==nil) then
			ElgohLooters[i] = ElgohLootFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal");
			ElgohLooters[i]:SetHeight(10);
			ElgohLooters[i]:SetPoint("TOPLEFT", ElgohLootFrame, "TOPLEFT", 10, 0-(15*i));
			ElgohLooters[i]:Hide();
		end
		if(InterestedRaiders[i]~=nil) then
			ElgohLooters[i]:SetText(InterestedRaiders[i]);
			ElgohLooters[i]:Show();
		else ElgohLooters[i]:Hide(); end
	end
end

function Elgoh_SortLooters(a,b)
	EDB_Snapshot(a);
	EDB_Snapshot(b);
	-- EDebug("a: "..EDB[a]["earned"].." "..EDB[a]["priority"]);
	-- EDebug("a: "..EDB[b]["earned"].." "..EDB[b]["priority"]);
	local EPGPT=ElgohSettings["EPGPThreshhold"];
	if((EDB[a]["earned"]>EPGPT and EDB[b]["earned"]>EPGPT) or (EDB[a]["earned"]<EPGPT and EDB[b]["earned"]<EPGPT)) then
		EDebug("Both above");
		return EDB[a]["priority"]>EDB[b]["priority"];
	elseif(EDB[a]["earned"]>EPGPT and EDB[b]["earned"]<EPGPT) then
		EDebug("A was above and B wasn't");
		return true;
	elseif(EDB[a]["earned"]<EPGPT and EDB[b]["earned"]>EPGPT) then
		EDebug("B was above and A wasn't");
		return false;
	end
end

function Elgoh_LootShow(link)
	local MaxLoot={};
	local r=0;
	local header=0;
	for i=1,GetNumLootItems() do
		local _,lootName,_,rarity = GetLootSlotInfo(i);
		if(LootSlotIsItem(i) and (rarity==4 or (rarity>1 and ElgohSettings["Debug"]==1))) then
			if(link==1 and header==0) then SendChatMessage("Linking loot for "..UnitName("TARGET"), "RAID"); header=1; end
			r=r+1;
			tinsert(MaxLoot,lootName);
			if(link==1) then 
				if(GetNumRaidMembers()>0) then SendChatMessage(r..": "..GetLootSlotLink(i), "RAID"); else SendChatMessage(r..": "..GetLootSlotLink(i), "SAY"); end
			end
			-- EDebug(i.."-"..r..": "..lootName);
		end 
	end
	if(link==1) then return; end
	if(r>0) then ElgohLootButtonLink:Show(); else ElgohLootButtonLink:Hide(); end
	--EDebug("MaxLoot="..#MaxLoot);
	if(not LootFrame.page) then LootFrame.page=1; end
	for i=1,4 do
		if(i==4 and (GetNumLootItems()>(4*LootFrame.page))) then return; end
		local _,_,_,rarity = GetLootSlotInfo(i+(4*(LootFrame.page-1)));
		if(rarity~=nil and (rarity==4 or (ElgohSettings["Debug"]==1 and rarity>1))) then
			ElgohLootButton[i]:Show();
			ElgohLootButton[i+4]:Show();
		else
			ElgohLootButton[i]:Hide();
			ElgohLootButton[i+4]:Hide();
		end
	end
end